/*
Lesson 2 : Atoms At Work

With this lesson we begin by learning more about the 6 types of
atoms.

The most commonly used ones are the ones we will focus on for now-
Mob- is a mobile object - aka something you'd use for a person
or other creature that is living.
Obj- is an object - this could be anything that doesn't move
on it's own.
Turf- This is the "ground" so to speak. Mobs and objects occupy
these spaces.
Area- This is the area in which everything else resides. Turfs have
regions "beneath" them, so anything inside the turf is also within
the area.

Nearly all atoms have a special a special list known as contents.
This list is a group of all other atoms that reside inside of the
atom you are accessing.

Use of areas/turfs-while not complex,is slightly different.
Turfs will mostly rely on their density as to how you work with
them. When the player moves, they Enter() into a turf,
if the turf is dense, they are disallowed entry. Once the player
has successfully entered the turf they will now be in the turf's
contents.

Areas work generally the same but they are more of a region,
think of the U.S. map, each state is  different,
though still residing within the U.S. Same with countries,
they all exist on Earth. An area is similiar in nature.

As mentioned in lesson 1- all atoms have code attached to them known as
procedures, variables and verbs. These will be the focus this lesson.

**Variable- also known as a var- this is a container that holds a value.
It could hold text, numbers or many other things. For example most atoms
have density, which determines how they react when they bump or are
Enter() calls.

**Procedure- also known as a proc- this is a group of instructions that
can be called by simply typing out the name of the proc. Procedures
can only be used by the atom they are attached to.

**Verb- this is a group of instructions with special uses and circum-
stances. Verbs are like procedures, except they can be used by others.

You would choose an atom that suits your task in programming; we will
begin with mobs. Mobs are most often used as players & enemies in
games. To best use a mob you must have a good understanding of what
makes it unique. The difference between a mob and all of the other atoms
is that it can move, on it's own. It has a set of vars &
procs dedicated to achieving this.

Procedures are numerous and completely explained in
the help file so I won't go into specifics about all of them here,
instead click the 'Help' menu and choose the 'Help On' option.

A window will pop up, click on the 'Topic' tab and type in 'mob' then
double-click on the highlighted line. This will bring you to a page that
describes mobs and a listing that says 'See also:' By clicking the
'procs (mob)' link on this page, you'll be treated to a full list of
the built in procs available to you when you use a mob type atom.

Click on Bump and Move and read their info, these are two of the most
used mob procs, check out any others you find interesting and don't
worry if you don't fully understand what the document is explaining.
The beauty of DM programming language is that you don't need to know
how to do much technical stuff to be able to produce a great game.

You can find procs and variables in this manner for each atom type by
using the 'Help'- which you can access by pressing F1 from the keyboard.

We will now begin the coding aspects of the lessons. I'll keep it fairly
simple to start out, you can always build upon things once you under-
stand the fundamental concepts.

Now lets take a look at vars,procs and verbs in code form.
*/
obj
	name="Spidunks"//all objects are now named spidunks.

turf
	density=1//means a dense mob cannot enter turfs.


area
	name="Desert"//desert area

/*mobthis is a mob declaration
	name="Bobbie"//preset var
	procthis is a keyword signaling that you are prepping a proc
		Heal()this is the actual declaration of the proc*/

/*
When programming you will notice that some of your script turns
different colors. This is a visual que from DM telling you that
you have happened upon a key-word. A key-word is a reserved word that
can't be used for any other purpose than what DM allows. In the example
above the key-word 'proc' means that following the line the compiler
expects a proc to be declared- in this case 'Heal()'.

The second thing you might notice in the indentations, which are very
important when writing code in DM.

The '//' is a comment. Area of code ignored by compilers useful for
writing text. '/*' and '*/' are also types of comments, anything
between them will be considered a comment-useful for longer text.

*/

//var/mob/m=new(locate(5,5,1))//creates a new mob at a location
//m.Heal()//calls the heal proc which at the moment does-nothing.


/*
The '/' slash is the same as pressing enter and indenting when coding
(but use sparingly).
The above code creates an 'instance' of a mob called m. You can then
use m however you please- in this case I called the Heal proc(which
means I used it.) But Heal is empty, lets fix that.

Go back up to the Heal proc and add this.
*/

/*mob/this is a mob declaration
	name="Bobbie"//text, the name of the mob, it's a pre set var.

	hp=100
	procthis is a keyword signaling that you are prepping a proc
		Heal()this is the actual declaration of the proc
			src<<"You regain some health."//sends text to src
			src.hp+=25adds 25 to hp.*/

/*
Here a variable has been added called hp. Using 'Heal()' will restore
25 hp to the mob that uses it as well as output a message saying
that they regain some health. The '<<' operator is a new addition which
can be used for a few things, look it up when you have a moment but
don't fret if you don't get all of it's uses.

We will now explore using verbs- which many can find a bit tricky so
I'll explain it simply. A verb is something that either you, or I can
do- in DM it's the same. If I declare a verb, it means that another
atom in the program may have access to it, it also means that other
players could have access to them as well. This is an important dis-
tinction to make.

Procedures are used for things that will only affect the atom in
question. For instance, you don't normally need help breathing. You
just do it- so "Breathe()" would be a proc. However you can "Eat()"
something on your own, or someone can aide you with "Eat()" by feed-
ing you. "Eat()" would be a verb in this case.

When using verbs there are two very important distinctions to be made
src, and usr. src is the atom that is calling the procedure or verb.

'usr' is the atom that happens to be using the verb in that instance.

So like in the above examples of "Breathe()" and "Eat()", if I was
feeing myself I would be the 'usr'. But if someone else was feeding me
they would be the 'usr'- however I would always be the 'src'- no matter
what, as long as I was the one being fed.

It seems a bit confusing but it's really simple once you get the gist
of it. That being said, do not use 'usr' in procs, always use 'src'.

Both procs and verbs can accept what are known as arguements.
These are variables or values passed into the procedure or verb that
allow them access to outside information.

In this case let's remake the 'Heal()' proc and use it again.
*/

mob//this is a mob declaration
	name="Bobbie"
	hp=100
	proc//this is a keyword signaling that you are prepping a proc
		Heal(var/amt)//the amt arguement has been added.
			src<<"You regain some health."
			src.hp+=amt

//---
/*var/mob/m=new(locate(1,5,2))
m.Heal(35)heal now accepts a number.*/

/*
As you might have noticed the benefit of a proc is that you can call
a group of instructions at once. The longer and more you fit into a proc
the more useful this becomes. In the above example Heal now restores
hp based on a number that is given to the procedure which is good,
being flexible and able to accomodate many situations is something
to strive for when coding.

In general procedures can accept many arguements of different types:
*/

/*proc
	Sort(var/number,var/txt,var/list/l)this accepts three types*/

// While verbs can only accept a few types under a specific condition:


/*verb
	Sort(var/m as text) this accepts text and will error otherwise.*/

/* The full list of arguements for verbs can be found in the 'Help'
as well thus I won't go over them. I'd also suggest looking at the
file in regards to proc as well.

The final piece of coding we will look at are operators, which
you've already seen in action- '+='. Operators are used to manipulate
numbers mathmatically. Each operator has a different function. There
are a few obvious ones such as '+' or '-'. The Help has a full list
explaining each and it's uses. It's important to get familiar with
most of them as you will be using them often.


As with anything in programming,you will learn and excel more quickly
if you choose to practice. I'd recommend making some procs until you
get the hang of it using what you have learned here. Lesson 3 will
go more in depth with the tools you have at your disposal for pro-
gramming.
*/