/*
Lesson 3- Conditions


What are conditions?
A condition is a set of circumstances you wish to test.

For instance, let's say I go shopping, I need the correct amount of
money to purchase whatever I need. In programming this is done using
conditional statements.

***if- checks to see if a condition is true or false.
***else- used in conjunction with the if statement
***else if- also used in conjunction with the if statement.
***switch- an advanced form of the if statement.

Let's take a look at how these are used: (Note indentation is VERY
important with statements.)

*/
mob
	var
		money=10000
	proc
		Spend(var/amt)//a proc that spends your money.
			if(money>=amt)//check to see if you have enough..
				money-=amt//deduct the money and notify.
				src<<"You spent [amt] money."
			else//if not, then notify them.
				src<<"You don't have enough money!"

/*
In the example above if you have enough money you will spend it.
Otherwise you'll get a message saying 'You don't have enough money!",
if and else is pretty straight forward. Let's try adding in an 'else if'.
*/

/*mob
	money=10000
	proc
		Spend(var/amt)//a proc that spends your money.
			if(money>amt)//check to see if you have enough..
				money-=amt//deduct the money and notify.
				src<<"You spent [amt] money."
			else if(money==amt)//you have enough but you're broke..
				money-=amt//deduct the money and notify.
				src<<"You spent all of your money! -_-"
			else//if not, then notify them.
				src<<"You don't have enough money!"*/


/*
In this case you can now tell the player that they have used all of
their money as well as the other two messages.

What happens when you have say- ten different conditions to check?

When the conditions are right, you can use a switch statement.
Switch statements will take one variable and compare it's value.

*/
mob
	proc
		Shop(var/choice)
			switch(choice)
				if("Hat")
					src<<"You bought a hat."
				if("Shoes")
					src<<"You bought some shoes."
				if(1)
					src<<"You purchased a #1 special."
				//and so on..

/*
As you can see above, depending on what your choice is, you will get a
different message.

-Loops
While coding you may also have a need for a more advanced type of
condition testing- loops.
Loops are code that will repeat a set of instructions until the condi-
tions are met to stop the loop. There are three types of loops:

***for() loop- often used for condition checking in loops.
***while() loop- repeats until broken
***do while() loop- repeats while a condition is true.

The simplest type of loop is the while loop.

WARNING: Infinite loops will crash your project. There are very few
times when you need an infinite loop, so for now always add a condition
to the while loop.

*/
//var/count=35number of loops to do.
//while(count>0)while the count is greater than 0
//	world<<" Loop! [count]"says to the world
//	count--//decrease count by 1.


/*do//a do while loop.
	world<<" Loop! [count]"says to the world
	count--decrease count by 1.
while(count>0)*/

/*
The two loops above are fairly simple-
The for loop takes some getting used to however.

When used with no arguements it functions exactly like a while loop.

When used with arguements it is an advanced type of condition checking.
The 'Help' file does an excellent job of explaining it's usage thus I'll
just show an example.
*/



/*for(i; i>10, i--)// as long as i is greater than 10, decrease it by 1
	world<<"Still looping!"*/


/*
With the above example, you no longer have to specifically decrease
the counter, it's done automatically each time the code runs.

The next lesson will focus on lists, as well as turfs, areas and datums.
*/








