/*
Lessons 4- The Rest.

As you may have noticed we skipped a few of the atom types in previous
lessons. That is because they are somewhat special.

***Lists- A group of items placed inside an indexed list(think a shopping
list )
***Datums- used to create custom atoms.

Lists can be either complex or simple, depending on your visualization
skills and how many lists are involved. There are a few important
things to remember when dealing with lists.

The first is, you must initialize them.
The second is that you can never access something that doesn't exist
inside the list.

There are a few different ways to initialize lists, press the 'F1' key
and search lists for more info, for now I will choose my most used
method:

*/
//var/list/shoppinglist=list("Eggs","Milk","Cheese")//creates a list and
//populates it.


/*
The list above is simple, I declare a variable of /list type and make it
equal to an empty list(), which I then fill with whatever I desire.
To then access what is inside of a list you use this method:
*/

//shoppinglist[1]//is equal to "Eggs"
//shoppinglist[2]//is equal to "Milk"
//shoppinglist[3]//is equal to "Cheese"

/*
Lists possess a few special procs as well as a few special variables,
the most useful one is probably 'len'. The len variable allows you to
see how many indexes a list has (the number of items in the list)

The shoppinglist has a len of 3. If I added more, the len would grow
accordingly.
*/

//shoppinglist.Add("Bacon","Butter","Biscuits","OJ")//now the len is 7.

/*
Using this we could make a proc that goes shopping for us!
*/

/*proc
	GoShop(list/l)checks the length of the list
		if(l.len > 5)if the items in the list are more than 5
			world<<"Shopping time. Items on the list were purchased!"
			l.Cut()removes all the items in the list.*/
/*
Check out the documents on lists in 'Help' for a full list of the
procs and vars associated with lists and what they do.


- The Misunderstood, Misused, Fabulous Datum

Datums are a bit of  a problem for most people. What they don't realize
is tht datums are simply "blank" atoms.

An atom devoid of any type of procs, variables or pre determined function
, so the question might occur- "Why do I need that?"

One of the simplest answers can be found in an example. Say you need
to give your character something like a skill- but you don't want your
skills to be objs or verbs or even procs. Let's say you want your skills
to be-just that a skill- but no atom fits what you need exactly-
that's where a datum comes in.


Datums are used just like any other atom EXCEPT you first have to
declare a datum and all of it's variables and procs/verbs. From then on
you can create new instances of your datum whenever you wish.
*/

/*Skilldatum declaration
	var
		name="Swords"datums don't have default names.
		level=1//current level of the sword skill
	proc
		LevelUp()
			level++increase this skill by 1!*/

//--then to create an instance of a Datum.
//var/Skill/S=new()//a new skill has been created.
//S.LevelUp()//skill has just increased.*/


/*
And that is really it in terms of using datums, deceptively simple.
These first four lessons are simply familiarizing you with the basics.
You need to know the building blocks before you attempt to build a
 castle. The next lessons will focus on exactly that, putting everything
 you've learn here in the first four lessons to use. As such not only
 will you learn twice as much, twice as fast but you will also
 grow more comfortable with programming in DM as well.
*/