/*
	These are simple defaults for your project.
 */

world
	fps = 25		// 25 frames per second
	icon_size = 32	// 32x32 icon size by default

	view = 6		// show up to 6 tiles outward from center (13x13 view)


// Make objects move 8 pixels per tick when walking

mob
	step_size = 8

obj
	step_size = 8

//Remember, I am not an expert. I will just write this how I understand it so I could be wrong or not very precise.  Check out BYOND's
// beginner articles too. It would be better to do that before you read this.



/* I'll start with what is an atom. Atom stands for area, turf, object and mobile. As of now, I don't know how to use the atom datum.
Each area, turf, object and mobile has a variable and a procedure. A variable is something that changes and a procedure is like a verb
but it needs to be called. To indent is to tab or create spaces that must be consistent in your code. It will be like a ladder. If its
not on then click CTRL+T and it will show the tabs you made. Use CTRL+L to see the line number of your code. If you assign a mob a
certain variable and give a value, that mob alone will have that variable. Let's do this:
*/

mob //which kind of atom using. You are the mob.
	verb //This programming is like stairs. This is stating this is a verb
		hit_yourself() //the name of the verb must end with parenthesis and if there are more than one word then use _ instead of space
			src.hp-=2 //src is who is the source of this programming. . is what you put afterwards and the variable's name after the . .
			src << "You were hit for 2 hp" // << is who is getting the output and then you add "" and inside them write whatever you want
	var //variable
		hp=10 //hit points number

//Here's one where the verb is in the object that all mobs can access:

obj
	torch
		verb
			light_up()
				set src in view(1) // this sets it so the verb is accessable to everyone within 1 tile away
				src.luminosity=6 //sets the set variable to 6 causing the torch to light up up to 6 tiles away. = means the former
								//takes the value of the latter
			put_out()
				set src in view(1)
				src.luminosity=0 //now the object's light doesn't cast off anymore past its tile


/* In the verb name's parenthesis you can create what is known as an argument. An argument is a parameter to a procedure. I recommend
going to the guide 5.1 to see the parameter types. Here is an example:*/

mob/verb/say(m as text)
	view(3) << "[src] says [m]" //notice the []. They show the value or variable of a variable.

//Use the for() loop for doing something over and over or checking every mob or obj:

mob/verb/Walk_North()
	var/i
	for(i=0,i<=10,i++) //this makes i=0 then checks if i is less than or equal to 10, does the statement below, then adds 1 to i
		step(src,NORTH)

mob/verb/who()
	var/counter
	for(var/mob/m in world)//checks every mob in the world
		counter++ //Adds to counter
		src << "[m] is online"
	src << "There are [counter] of people online"


//Turning activity on/off:

mob
	var
		eating=0
	verb
		eat()
			src.eating=!src.eating //switches the verb on/off
			if(src.eating) //checks if eating verb is on
				usr << "You began eating"
			else
				usr << "You stop eating"

//Create something:

mob
	verb
		create_torch()
			new/obj/torch(loc) //loc as an argument to pass on when the predefined proc New() works

//How to start a loop proc when an atom is created:

mob
	New()
		src.heal()
	proc
		heal()
			while(++src.hp) //As long as src.hp(src is source, you) exists over 0, do this loop. It adds to health then checks it.
				sleep(10) //Delay every 1 second so that the loop won't be infinite

//Combining predefined procs and if operators:

mob
	verb
		coin_toss()
			if(prob(50)) //probability proc inside the if statement
				src << "You got heads"
			else //Don't use else if here. This one works if the first one fails. If you used else if it could fail too.
				src << "You got tails"

//Passing on arguments to procs:

mob/
	verb
		punch(mob/m in view(1)) //Defines the variable m as a mob and only in view of 1 tile away
			src.hit(m)
	proc
		hit(mob/m)
			m.hp--
			src << "You hit [src]"

//Making targets by clicks:

mob
	var
		target=null
	Click()//If you click on a mob
		usr.target=src // usr= the one doing the click. src= the source of the click
		usr << "You have targetted [src]"
	verb
		hit_target()
			if(src.target!=null)//Checks if there is a target by asking if its not null
				src.hit(src.target)

//Using a proc as true or false:

mob
	var
		isstrong=0
	verb
		check_test()
			if(src.strength_test()) //Checks if the strength_test returns 1 or 0. 1 means true, 0 means false. return also stops
									//any following iterations.
				src << "You are strong"
			else
				src << "You are not strong"
		change_strength()
			usr.isstrong=!usr.isstrong //Change whether or not you are strong
			if(src.isstrong)
				src << "You became strong"
			else
				src << "You are became not strong"
	proc
		strength_test()
			if(src.isstrong)
				return 1 //If your variable isstrong is true, return true.
			else
				return 0 //Else return false

//Inputs:

mob
	verb
		inputname()
			src.name=input("What is your name?") as text
			src.gender=input("What is your gender?") in list ("male", "female", "neuter")
			switch(alert("Would you like to continue?",, "Yes", "No"))
				if("Yes")
					     //do something
					return
				if("No")
					     //do something
					return
			if(alert("Would you like to stop?",,"Yes", "No")=="Yes")
				     //do something
				return

//Get step and get dist:

mob
	verb
		check_turf()
			for(var/mob/m in get_step(usr, usr.dir)) // get_step() checks the turf of a reference in a direction.
				if(m) //if m exists
					src << "[m] is in front of you"
		check_dist(mob/M in world)
			var/distance=get_dist(usr,M)//Or you could do if(get_dist(usr,M)==1))
			if(distance==1)
				src << "[M] is right by you"
			else if(distance>1 && distance<=8)
				src << "You can see [M]"
			else if(distance>8)
				src << "[M] is unseen as /he's far away"

//To find any obj or turf: var/obj/torch=locate(/obj/torch)

//Also: var/obj/x=locate(/obj/x) in usr. in is used to access list

//Stop attack from being abused:

mob
	var
		attacked=0
	verb
		attack()
			if(src.attacked)
				return//stops the verb from being abused when its not time to attack
			//attack
			src.attacked=1//after attacked make this variable true
			sleep(10)//wait 1 second
			src.attacked=0//the variable is false again so you can attack again

//Hit the facing mob:

mob/verb/punch_forward()
	for(var/mob/m in get_step(src,src.dir))
		--m.hp

//another way:

mob/verb/punch_forward_two()
	var/mob/object=locate() in get_step(src,src.dir)
	--object:hp